	.section .note.GNU-stack
	.data
	.globl	a
	.align	8
	.type	a, @object
	.size	a, 8
a:
	.quad	0x0

	.data
	.globl	b
	.align	8
	.type	b, @object
	.size	b, 8
b:
	.quad	0x0

	.text
	.globl	func
	.type	func, @function
func:
	push	%rbp
	mov	%rsp, %rbp
	push	%rbx
	push	%rsi
	push	%rdi
	sub	$0x0, %rsp
	mov	$0x1234567, %rax
	mov	$a, %rdx
	mov	%rax, 0x0(%rdx)
	mov	$0x89abcdef, %rax
	mov	$b, %rdx
	mov	%rax, 0x0(%rdx)
	mov	$.LC0, %rax
	mov	%rax, %rdi
	mov	a(%rip), %rax
	mov	%rax, %rsi
	push	%rbx
	mov	%rsp, %rbx
	and	$0xfffffffffffffff0, %rsp
	call	printf
	mov	%rbx, %rsp
	pop	%rbx
	mov	%rax, %rbx
	mov	$.LC1, %rax
	mov	%rax, %rdi
	mov	b(%rip), %rax
	mov	%rax, %rsi
	push	%rbx
	mov	%rsp, %rbx
	and	$0xfffffffffffffff0, %rsp
	call	printf
	mov	%rbx, %rsp
	pop	%rbx
	mov	%rax, %rbx
	mov	$a, %rax
	mov	0x0(%rax), %rax
	mov	%rax, %rbx
	mov	$.LC2, %rax
	mov	%rax, %rdi
	mov	%rbx, %rax
	mov	%rax, %rsi
	push	%rbx
	mov	%rsp, %rbx
	and	$0xfffffffffffffff0, %rsp
	call	printf
	mov	%rbx, %rsp
	pop	%rbx
	mov	%rax, %rbx
	mov	$b, %rax
	mov	0x0(%rax), %rax
	mov	%rax, %rbx
	mov	$.LC3, %rax
	mov	%rax, %rdi
	mov	%rbx, %rax
	mov	%rax, %rsi
	push	%rbx
	mov	%rsp, %rbx
	and	$0xfffffffffffffff0, %rsp
	call	printf
	mov	%rbx, %rsp
	pop	%rbx
	mov	%rax, %rbx
	mov	$0x0, %rax
	mov	-0x8(%rbp), %rbx
	mov	-0x10(%rbp), %rsi
	mov	-0x18(%rbp), %rdi
	leave
	ret
	.text
	.globl	main
	.type	main, @function
main:
	push	%rbp
	mov	%rsp, %rbp
	push	%rbx
	push	%rsi
	push	%rdi
	sub	$0x0, %rsp
	push	%rbx
	mov	%rsp, %rbx
	and	$0xfffffffffffffff0, %rsp
	call	func
	mov	%rbx, %rsp
	pop	%rbx
	mov	$0x0, %rax
	mov	-0x8(%rbp), %rbx
	mov	-0x10(%rbp), %rsi
	mov	-0x18(%rbp), %rdi
	leave
	ret

	.data
.LC3:	.string	"%lx\n"
.LC2:	.string	"%lx\n"
.LC1:	.string	"%lx\n"
.LC0:	.string	"%lx\n"
